/***********************************************************
* Copyright (c) 2009-2010 OpenVox Communication Co.,Ltd.
* All Rights Reserved.	
* Author: mark.liu@openvox.cn
***********************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "menu.h"


/************************************************************************
 * ˵ʾ
 ************************************************************************/
void menu_show( t_menu_item *pmenu, int items, int flag)
{
	int i;

	if (MENU_CLEAR_TRUE == flag) {
		printf("%s",   "\033[1H\033[2J"); //clear
	}
	
	for(i = 0; i < items; i++) {
//		printf("\t");
		puts(pmenu[i].name);
	}
}


/************************************************************************
 * ˵ѡ
 * һַѡ˵ز˵
 * ˵ڣʾUnknown inputͬʱʾ˵
 ************************************************************************/
int menu_choose(t_menu_item *pmenu, int items)
{
	char buf[4];
	char ch;
	int i;
	int ret;
	
	//menu_show(pmenu, items, MENU_CLEAR_TRUE);
	menu_show(pmenu, items, MENU_CLEAR_FALSE);
	while(1)
	{
		
		printf("[1-%d] : ", items);
		setbuf(stdin, NULL);
		memset(buf, 0, 4);
		
		i = 0;
		while((ch = getchar()) != '\n') {
			buf[i++] = ch;
			if (i == 4) {
				break;
			}
		}

		if (buf[0] == '\0') {
			fprintf(stderr, "\nError: Invalid option, input an integer\n");
			continue;
		}
		
		buf[3] = '\0';
		ret = atoi(buf);
//		printf("buf = %s\n", buf);
//		printf("ret = %d\n", ret);
		if(ret == 0) {
			return 0;
		}
		else
		{
//			printf("items = %d\n", items);
			for(i = 0; i < items; i++)
			{
//				printf("pmenu[i].hotkey = %d\tch = %d\n", pmenu[i].hotkey, ret);
				if(pmenu[i].hotkey == ret) {
					printf("\n");
					return ret;
				}
			}
			fprintf(stderr, "\nError: Invalid option, input a value between 1 and %d\n", items);
		}
	}	
}


int menu_new_items(t_menu_item *menu, int num)
{
	
	menu = (t_menu_item *)calloc(num, sizeof(t_menu_item));
	if (!menu) {
		printf("memory calloc error!\n");
		return -1;
	}
	
	return 0;
}


int menu_destroy_items(t_menu_item *menu)
{
	if (menu) {
		free(menu);
	}
	return 0;
}

