#ifndef _CARDS_FLASH__
#define _CARDS_FLASH__

//===================================================================================
// d430/d230/d130  d410g2/d210g2/d115g2
//===================================================================================
//d830
#define D830_EPCS_BASE                          0x00000800
#define D830_EPCS_OFFSET                        0x400
#define D830_C3RELOAD_BASE                      0x00000000
#define D830_C3RELOAD_OFFSET                    0x70
#define D830_VENDOR_ID                          0xd161
#define D830_DEVICE_ID                          0x1820

//d430
#define D430_EPCS_BASE                          0x00000800
#define D430_EPCS_OFFSET                        0x400
#define D430_C3RELOAD_BASE                      0x00000000
#define D430_C3RELOAD_OFFSET                    0x70
#define D430_VENDOR_ID                          0xd161
#define D430_DEVICE_ID                          0x1420

#define OPVX_D430_EPCS_BASE                          0x00000800
#define OPVX_D430_EPCS_OFFSET                        0x400
#define OPVX_D430_C3RELOAD_BASE                      0x00000000
#define OPVX_D430_C3RELOAD_OFFSET                    0x70
#define OPVX_D430_VENDOR_ID                          0x1b74
#define OPVX_D430_DEVICE_ID                          0xd430


//d420
#define D230_EPCS_BASE                          0x00000800
#define D230_EPCS_OFFSET                        0x400
#define D230_C3RELOAD_BASE                      0x00000000
#define D230_C3RELOAD_OFFSET                    0x70
#define D230_VENDOR_ID                          0xd161
#define D230_DEVICE_ID                          0x1220

#define OPVX_D230_EPCS_BASE                          0x00000800
#define OPVX_D230_EPCS_OFFSET                        0x400
#define OPVX_D230_C3RELOAD_BASE                      0x00000000
#define OPVX_D230_C3RELOAD_OFFSET                    0x70
#define OPVX_D230_VENDOR_ID                          0x1b74
#define OPVX_D230_DEVICE_ID                          0xd230

//d130
#define D130_EPCS_BASE                          0x00000800
#define D130_EPCS_OFFSET                        0x400
#define D130_C3RELOAD_BASE                      0x00000000
#define D130_C3RELOAD_OFFSET                    0x70
#define D130_VENDOR_ID                          0x1b74
#define D130_DEVICE_ID                          0xd130

//d410g2
#define D410G2_EPCS_BASE                        0x00000800
#define D410G2_EPCS_OFFSET                      0x400
#define D410G2_C3RELOAD_BASE                    0x00000000
#define D410G2_C3RELOAD_OFFSET                  0x70
#define D410G2_VENDOR_ID                        0xd161
#define D410G2_DEVICE_ID                        0x1410

#define OPVX_D410G2_EPCS_BASE                        0x00000800
#define OPVX_D410G2_EPCS_OFFSET                      0x400
#define OPVX_D410G2_C3RELOAD_BASE                    0x00000000
#define OPVX_D410G2_C3RELOAD_OFFSET                  0x70
#define OPVX_D410G2_VENDOR_ID                        0x1b74
#define OPVX_D410G2_DEVICE_ID                        0xd410

//d210g2
#define D210G2_EPCS_BASE                        0x00000800
#define D210G2_EPCS_OFFSET                      0x400
#define D210G2_C3RELOAD_BASE                    0x00000000
#define D210G2_C3RELOAD_OFFSET                  0x70
#define D210G2_VENDOR_ID                        0xd161
#define D210G2_DEVICE_ID                        0x1210

#define OPVX_D210G2_EPCS_BASE                        0x00000800
#define OPVX_D210G2_EPCS_OFFSET                      0x400
#define OPVX_D210G2_C3RELOAD_BASE                    0x00000000
#define OPVX_D210G2_C3RELOAD_OFFSET                  0x70
#define OPVX_D210G2_VENDOR_ID                        0x1b74
#define OPVX_D210G2_DEVICE_ID                        0xd210

//d115g2
#define D115G2_EPCS_BASE                        0x00000800
#define D115G2_EPCS_OFFSET                      0x400
#define D115G2_C3RELOAD_BASE                    0x00000000
#define D115G2_C3RELOAD_OFFSET                  0x70
#define D115G2_VENDOR_ID                        0x1b74
#define D115G2_DEVICE_ID                        0xd110

//===================================================================================
// a2410/1610/0810 
//===================================================================================

//a2410
#define A2410_EPCS_BASE                         0x0000a800
#define A2410_EPCS_OFFSET                       0x400
#define A2410_C3RELOAD_BASE                     0x00000000
#define A2410_C3RELOAD_OFFSET                   0x70
#define A2410_VENDOR_ID                         0x1b74
#define A2410_DEVICE_ID                         0x2410

//a1610
#define A1610_EPCS_BASE                         0x0000a800
#define A1610_EPCS_OFFSET                       0x400
#define A1610_C3RELOAD_BASE                     0x00000000
#define A1610_C3RELOAD_OFFSET                   0x70
#define A1610_VENDOR_ID                         0x1b74
#define A1610_DEVICE_ID                         0x1610

//a0810
#define A810_EPCS_BASE                          0x0000a800
#define A810_EPCS_OFFSET                        0x400
#define A810_C3RELOAD_BASE                      0x00000000
#define A810_C3RELOAD_OFFSET                    0x70
#define A810_VENDOR_ID                          0x1b74
#define A810_DEVICE_ID                          0x0810

//===================================================================================
// G400 
//===================================================================================
//g400p
#define G400_EPCS_BASE                          0x00002800
#define G400_EPCS_OFFSET                        0x400
#define G400_C3RELOAD_BASE                      0x000005d8
#define G400_C3RELOAD_OFFSET                    0x0
#define G400_VENDOR_ID                          0x1b74
#define G400_DEVICE_ID                          0x0100

//===================================================================================
// X200
//===================================================================================
#define X200_EPCS_BASE                          0x00001800
#define X200_EPCS_OFFSET                        0x400
#define X200_C3RELOAD_BASE                      0x00000440
#define X200_C3RELOAD_OFFSET                    0x0
#define X200_VENDOR_ID                          0x1b74
#define X200_DEVICE_ID                          0xC200
//#define X200_VENDOR_ID                          0x1172
//#define X200_DEVICE_ID                          0x0004
#endif

